#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>
#include "multiboot.h"
#include "term.h"
/* Check if the compiler thinks you are targeting the wrong operating system. */
#if defined(__linux__)
#error "You are not using a cross-compiler, you will most certainly run into trouble"
#endif
 
/* This tutorial will only work for the 32-bit ix86 targets. */
#if !defined(__i386__)
#error "This tutorial needs to be compiled with a ix86-elf compiler"
#endif

kVGATerm vgaterm;


void int_to_string(char * str, size_t strlen, size_t conv) {
	char buffer[100];
	for (int i = 0; i < 100; i++) {
		buffer[i] = -1;
	}

	size_t startpos = 0;
	while (conv != 0) {
		buffer[startpos] = (conv % 10) + 48;
		conv = conv / 10;
		startpos = startpos + 1;
	}
	size_t maxindex = startpos - 1;

	int j = 0;
	for (int i = maxindex; i >= 0; i--) {
		if (i >= strlen) {
			
		} else {
		str[i] = buffer[j];
		j = j + 1;
		}
	}
}

void os_vga_writestring(char * data) {
	terminal_writestring(&vgaterm, data);
}
 
void kernel_main(unsigned long addr) {
	/* Initialize terminal interface */
	//kVGATerm vgaterm;
	terminal_initialize(&vgaterm);
	//uint32_t * flags = (uint32_t *) addr;

	/* Newline support is left as an exercise. */

	multiboot_info_t *mbi = (multiboot_info_t *) addr;

	char x[50];
	for (int i = 0; i < 50; i++) {
		x[i] = -1;
	}
	int_to_string(x, 50, mbi->mem_lower);
	os_vga_writestring(x);
	os_vga_writestring("\n");

	for (int i = 0; i < 50; i++) {
		x[i] = -1;
	}

	int_to_string(x, 50, mbi->mem_upper);

	os_vga_writestring(x);
	os_vga_writestring("\n");


	os_vga_writestring("erm what da sigma\n");
	os_vga_writestring("Hello, kernel World!\n");
	os_vga_writestring("Hello, kernel World!\n");
	os_vga_writestring("Hello, kernel World!\n");
}
